module Xtend
  module LitaWizard
    # rubocop:disable Style/CyclomaticComplexity
    def handle_message
      if message.body =~ /(^\/cancelar$|^cancelar$|^abortar$|^não$|^nao$|^pare$|^para$)/
        send_message abort_message
        abort_wizard
        destroy
      elsif step.nil?
        send_message 'Opa, tive um probleminha e por isso cancelei esse procedimento.'
        destroy
      elsif message.body =~ /(^concluir$|^ok$|^feito$)/  && step[:multiline]
        save
        advance
      elsif valid_response?
        if step[:multiline]
          values[current_step_index] ||= ''
          values[current_step_index] << "\n"
          values[current_step_index] << message.body
          values[current_step_index].strip!
          save
        else
          values[current_step_index] = message.body
          save
          advance
        end
      else
        send_message @error_message
      end
    end
  end
end